import { Component, Inject } from '@angular/core';
import { MatDialogRef, MAT_DIALOG_DATA } from '@angular/material/dialog';

@Component({
  selector: 'app-delete-confirm-dialog',
  template: `
  <h1 mat-dialog-title i18n="@@delete-dialog-title">Eliminar</h1>
<div mat-dialog-content>
  <p i18n="@@delete-dialog-content">¿Quiere borrar los clientes situados en {{data.name}} o quiere resituarlos en el nivel superior?</p>
</div>
<div mat-dialog-actions>
  <button mat-button (click)="deleteClick()" i18n="@@delete-all-clients-button">Borrar todos los clientes</button>
  <button mat-button (click)="changeClick()" i18n="@@reposition-clients-button">Resituar</button>
</div>

  
  `
})
export class DeleteGroupsModalComponent {
  constructor(
    public dialogRef: MatDialogRef<DeleteGroupsModalComponent>,
    @Inject(MAT_DIALOG_DATA) public data: { name: string }
  ) {}

  deleteClick(): void {
    this.dialogRef.close('delete');
  }

  changeClick(): void {
    this.dialogRef.close('change');
  }
}
