import { Component, Inject } from '@angular/core';
import { MatDialogRef, MAT_DIALOG_DATA } from '@angular/material/dialog';

@Component({
  selector: 'app-delete-confirm-dialog',
  template: `
  <h1 mat-dialog-title i18n="@@deleteDialogTitle">Eliminar</h1>
  <div mat-dialog-content>
    <p i18n="@@deleteConfirmationMessage">¿Estás seguro que deseas eliminar {{data.name}}?</p>
  </div>
  <div mat-dialog-actions>
    <button mat-button (click)="onNoClick()" i18n="@@cancelButton">Cancelar</button>
    <button mat-button (click)="onYesClick()" i18n="@@confirmButton">Eliminar</button>
  </div>
  
  `
})
export class DeleteModalComponent {
  constructor(
    public dialogRef: MatDialogRef<DeleteModalComponent>,
    @Inject(MAT_DIALOG_DATA) public data: { name: string }
  ) {}

  onNoClick(): void {
    this.dialogRef.close(false);
  }

  onYesClick(): void {
    this.dialogRef.close(true);
  }
}
