import { HttpClient } from '@angular/common/http';
import { Component, Inject } from '@angular/core';
import { MatDialogRef, MAT_DIALOG_DATA } from '@angular/material/dialog';
import { ToastrService } from 'ngx-toastr';

@Component({
  selector: 'app-edit-image',
  templateUrl: './edit-image.component.html',
  styleUrls: ['./edit-image.component.css']
})
export class EditImageComponent {
  name: string = '';
  downloadUrl: string = '';

  constructor(
    private toastService: ToastrService,
    private http: HttpClient,
    public dialogRef: MatDialogRef<EditImageComponent>,
    @Inject(MAT_DIALOG_DATA) public data: any
  ) {
    // Rellenar los campos con los datos recibidos
    if (data) {
      this.name = data.name;
      this.downloadUrl = data.downloadUrl;
    }
  }

  onNoClick(): void {
    this.dialogRef.close();
  }

  editOgLive(): void {
    const payload = {
      name: this.name,
      downloadUrl: this.downloadUrl
    };

    // Realizar PATCH para editar la imagen
    this.http.patch(`http://127.0.0.1:8080/og-lives/${this.data.uuid}`, payload)
      .subscribe({
        next: (response) => {
          console.log('Success:', response);
          this.toastService.success('Image updated successfully');
          this.dialogRef.close();
        },
        error: (error) => {
          console.error('Error:', error);
          this.toastService.error('Error updating image');
        }
      });
  }
}
